/*
 * config.h
 *
 *  Created on: Jul 27, 2024
 *      Author: true
 */

#ifndef USER_SRC_CONFIG_H_
#define USER_SRC_CONFIG_H_


#include <stdint.h>
#include <ch32v20x.h>


#define CONF_FLASH_ADDR_BASE    FLASH_BASE
#define CONF_FLASH_PAGE_SIZE    256         // CH32V20x is 256-byte page in fast mode
#define CONF_FLASH_PAGES        8           // wear leveling pages

#define CONF_CURSOR_WHITE       0
#define CONF_CURSOR_GREEN       1
#define CONF_CURSOR_ORANGE      2
#define CONF_CURSOR_OFF         3

#define CONF_CURSOR_SELECT_MASK 0x03
#define CONF_CURSOR_FLASH_MASK  0x70
#define CONF_CURSOR_FLASH_SHIFT 4

#define CHECKVAL                0x2024dc32



typedef struct UserConf {
    uint32_t version;
    uint8_t pep_conf[8][4];
    uint8_t rgb_conf[4][4];
    uint8_t pep_prog_ena_map;
    uint8_t rgb_prog_ena_map;
    uint16_t checksum;
    uint32_t checkval;
} UserConf;     // 60 bytes



extern struct UserConf userconf;



void userconf_load();
void userconf_save();



#endif /* USER_SRC_CONFIG_H_ */
