/*
 * Created on: Jul 28, 2024
 */

#ifndef USER_SRC_LED_H_
#define USER_SRC_LED_H_



#include <stdint.h>

#include "31fl3729.h"



#define FL3729_ADDR     (FL3729_BASE_ADDR | FL3729_ADPIN_GND)

#define LED_PEP_COUNT   36      // all pepper body LEDs
#define LED_PEP_NOTOP   31      // pepper body LEDs not including the part under the hat
#define LED_HAT_COUNT   28      // all pepper hat LEDs
#define LED_ALL_COUNT   (LED_PEP_COUNT + LED_HAT_COUNT)



typedef struct LedMatrix {
    union {
        uint8_t pep[LED_PEP_COUNT];
        uint8_t hat[LED_HAT_COUNT];
    };
    uint8_t all[LED_ALL_COUNT];
} LedMatrix;



extern struct LedMatrix led;
extern uint8_t rgb[3];



void use_brightest(uint8_t *dest, uint8_t *compare, uint8_t count);

void led_init();

void led_matrix_is_updated();
void led_matrix_send();

void led_rgb_update();



#endif /* USER_SRC_LED_H_ */
